//+------------------------------------------------------------------+
//|                                                    Equity_v8.mq4 |
//|                                         Copyright  2008, Xupypr |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, Xupypr"

#property indicator_separate_window
#property indicator_buffers 8
#property indicator_color1 SkyBlue
#property indicator_color2 DodgerBlue
#property indicator_color3 CLR_NONE
#property indicator_color4 SkyBlue
#property indicator_color5 DodgerBlue
#property indicator_color6 CLR_NONE
#property indicator_color7 SkyBlue
#property indicator_color8 OrangeRed
#property indicator_width1 3
#property indicator_width2 3
#property indicator_width3 3
#property indicator_width4 1
#property indicator_width5 1
#property indicator_width6 3
#property indicator_width7 1
#property indicator_width8 2
#define period PERIOD_M1

extern string   Only_Magics="";     //        (  )
extern string   Only_Symbols="";    //     (  )
extern bool     Only_Current=false; //    
extern bool     Show_Balance=true; //  
extern bool     Show_Equity=true;  //  
extern bool     Show_Info=false;   //   

int      ANumber,Window;
bool     First;
double   EquityBodyUp[],EquityBodyDown[],MaskBody[],EquityShadeUp[],EquityShadeDown[],MaskShade[],EquityLine[],Balance[];
double   CurrentBalance,StartBalance,MaxProfit,Drawdown,MaxPeak,RecoveryFactor;
string   Shortname;
datetime TimeBar;

datetime OpenTime_Ticket[][2]; //     
int      OpenBar[];            //   
int      CloseBar[];           //   
int      Type[];               //  
string   Instrument[];         // 
double   Lots[];               //  
double   OpenPrice[];          //  
double   ClosePrice[];         //  
double   Commission[];         // 
double   Swap[];               //  
double   CurSwap[];            //  
double   DaySwap[];            //  
double   Profit[];             //  
double   Magic[];              //  

//+----------------------------------------------------------------------------+
//|  Custom indicator initialization function                                  |
//+----------------------------------------------------------------------------+
int init()
{
 if (Only_Magics=="" && Only_Symbols=="" && !Only_Current) Shortname="Total";
 else
 {
  if (Only_Magics!="") Shortname=Only_Magics; else Shortname="0";
  if (Only_Symbols!="") Shortname=StringConcatenate(Shortname," ",Only_Symbols);
  else if (Only_Current) Shortname=StringConcatenate(Shortname," ",Symbol());
 }
 SetIndexBuffer(0,EquityBodyUp);
 SetIndexLabel(0,Shortname+" Equity");
 SetIndexStyle(0,DRAW_HISTOGRAM);
 SetIndexBuffer(1,EquityBodyDown);
 SetIndexLabel(1,Shortname+" Equity");
 SetIndexStyle(1,DRAW_HISTOGRAM);
 SetIndexBuffer(2,MaskBody);
 SetIndexLabel(2,"Mask");
 SetIndexStyle(2,DRAW_HISTOGRAM);
 SetIndexBuffer(3,EquityShadeUp);
 SetIndexLabel(3,Shortname+" Equity");
 SetIndexStyle(3,DRAW_HISTOGRAM);
 SetIndexBuffer(4,EquityShadeDown);
 SetIndexLabel(4,Shortname+" Equity");
 SetIndexStyle(4,DRAW_HISTOGRAM);
 SetIndexBuffer(5,MaskShade);
 SetIndexLabel(5,"Mask");
 SetIndexStyle(5,DRAW_HISTOGRAM);
 SetIndexBuffer(6,EquityLine);
 SetIndexLabel(6,Shortname+" Equity");
 SetIndexStyle(6,DRAW_LINE);
 SetIndexBuffer(7,Balance);
 SetIndexLabel(7,Shortname+" Balance");
 SetIndexStyle(7,DRAW_LINE);
 if (Show_Equity)  Shortname=StringConcatenate(Shortname," Equity");
 if (Show_Balance) Shortname=StringConcatenate(Shortname," Balance");
 IndicatorShortName(Shortname);
 IndicatorDigits(2);
 ANumber=AccountNumber();
 First=true;
 TimeBar=0;
 return(0);
}
//+----------------------------------------------------------------------------+
//|  Custom indicator deinitialization function                                |
//+----------------------------------------------------------------------------+
int deinit()
{
 ObjectsDeleteAll(Window);
 return(0);
}
//+----------------------------------------------------------------------------+
//|  Custom indicator iteration function                                       |
//+----------------------------------------------------------------------------+
int start()
{
 static bool open;
 string name,text;
 static string symbols="";
 static double equityopen,equityhigh,equitylow,equityclose;
 double spread,lotsize;
 int bar,i,j,start,total,historytotal,opentotal;
 //int tick=GetTickCount();

 if (ANumber!=AccountNumber())
 {
  ArrayInitialize(EquityBodyUp,EMPTY_VALUE);
  ArrayInitialize(EquityBodyDown,EMPTY_VALUE);
  ArrayInitialize(MaskBody,EMPTY_VALUE);
  ArrayInitialize(EquityShadeUp,EMPTY_VALUE);
  ArrayInitialize(EquityShadeDown,EMPTY_VALUE);
  ArrayInitialize(MaskShade,EMPTY_VALUE);
  ArrayInitialize(EquityLine,EMPTY_VALUE);
  ArrayInitialize(Balance,EMPTY_VALUE);
  ObjectsDeleteAll(Window);
  ANumber=AccountNumber();
  symbols="";
  First=true;
  TimeBar=0;
 }
 if (!IsConnected())
 {
  Print("     ");
  return(0);
 }
 if (!OrderSelect(0,SELECT_BY_POS,MODE_HISTORY)) return(0);
 Window=WindowFind(Shortname);
 if (First)
 {
  First=false;
  historytotal=OrdersHistoryTotal();
  opentotal=OrdersTotal();
  total=historytotal+opentotal;
  ArrayResize(OpenTime_Ticket,total);
  for (i=0;i<historytotal;i++) if (OrderSelect(i,SELECT_BY_POS,MODE_HISTORY))
  {
   if (Select())
   {
    OpenTime_Ticket[i][0]=OrderOpenTime();
    OpenTime_Ticket[i][1]=OrderTicket();
   }
   else
   {
    OpenTime_Ticket[i][0]=EMPTY_VALUE;
    total--;
   }
  }
  if (opentotal>0)
  {
   for (i=0;i<opentotal;i++) if (OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
   {
    if (Select())
    {
     OpenTime_Ticket[historytotal+i][0]=OrderOpenTime();
     OpenTime_Ticket[historytotal+i][1]=OrderTicket();
    }
    else
    {
     OpenTime_Ticket[historytotal+i][0]=EMPTY_VALUE;
     total--;
    }
   }
  }
  ArraySort(OpenTime_Ticket);
  ArrayResize(OpenTime_Ticket,total);
  ArrayResize(OpenBar,total);
  ArrayResize(CloseBar,total);
  ArrayResize(Type,total);
  ArrayResize(Lots,total);
  ArrayResize(Instrument,total);
  ArrayResize(OpenPrice,total);
  ArrayResize(ClosePrice,total);
  ArrayResize(Commission,total);
  ArrayResize(Swap,total);
  ArrayResize(CurSwap,total);
  ArrayResize(DaySwap,total);
  ArrayResize(Profit,total);
  ArrayResize(Magic,total);
  for (i=0;i<total;i++) if (OrderSelect(OpenTime_Ticket[i][1],SELECT_BY_TICKET)) ReadDeals(i);
  if (Type[0]<6)
  {
   Alert("    ");
   return(0);
  }
  start=0;
  CurrentBalance=0.0;
  StartBalance=0.0;
  MaxProfit=0.0;
  Drawdown=0.0;
  MaxPeak=0.0;
  equityopen=0.0;
  open=true;
  TimeBar=iTime(NULL,0,iBarShift(NULL,0,OpenTime_Ticket[0][0]));
  for (i=OpenBar[0];i>=0;i--)
  {
   if (iTime(NULL,period,i)>=TimeBar+Period()*60 || i==0)
   {
    bar=iBarShift(NULL,0,TimeBar);
    TimeBar=iTime(NULL,0,iBarShift(NULL,0,iTime(NULL,period,i)));
    if (Show_Balance) Balance[bar]=NormalizeDouble(CurrentBalance,2);
    if (Show_Equity)
    {
     if (equityopen<=equityclose)
     {
      EquityBodyUp[bar]=NormalizeDouble(equityclose,2);
      MaskBody[bar]=NormalizeDouble(equityopen,2);
      EquityShadeUp[bar]=NormalizeDouble(equityhigh,2);
     }
     else
     {
      EquityBodyDown[bar]=NormalizeDouble(equityopen,2);
      MaskBody[bar]=NormalizeDouble(equityclose,2);
      EquityShadeDown[bar]=NormalizeDouble(equityhigh,2);
     }
     MaskShade[bar]=NormalizeDouble(equitylow,2);
     if (equityhigh==equitylow) EquityLine[bar]=equityhigh;
    }
    if (i!=0)
    {
     equityopen=0.0;
     open=true;
    }
   }
   equityclose=0.0;
   for (j=start;j<total;j++)
   {
    if (OpenBar[j]<i) break;
    if (CloseBar[start]>i) start++;
    if (CloseBar[j]==i && ClosePrice[j]!=0) CurrentBalance+=Swap[j]+Commission[j]+Profit[j];
    else if (OpenBar[j]>=i && CloseBar[j]<=i)
    {
     if (Type[j]>5)
     {
      CurrentBalance+=Profit[j];
      StartBalance+=Profit[j];
      name=StringConcatenate("Time: ",TimeToStr(iTime(NULL,period,i)));
      if (ObjectFind(name)==-1) ObjectCreate(name,OBJ_VLINE,Window,iTime(NULL,period,i),0);
      ObjectSetText(name,StringConcatenate(Instrument[j],": ",DoubleToStr(Profit[j],2)));
      ObjectSet(name,OBJPROP_TIME1,iTime(NULL,period,i));
      ObjectSet(name,OBJPROP_COLOR,OrangeRed);
      ObjectSet(name,OBJPROP_WIDTH,2);
      continue;
     }
     if (MarketInfo(Instrument[j],MODE_POINT)==0)
     {
      if (StringFind(symbols,Instrument[j])==-1)
      {
       Alert("     "+Instrument[j]);
       symbols=StringConcatenate(symbols," ",Instrument[j]);
      }
      continue;
     }
     bar=iBarShift(Instrument[j],period,iTime(NULL,period,i));
     if (TimeDayOfWeek(iTime(Instrument[j],period,bar))!=TimeDayOfWeek(iTime(Instrument[j],period,bar+1)) && OpenBar[j]!=bar)
     {
      switch (MarketInfo(Instrument[j],MODE_PROFITCALCMODE))
      {
       case 0:
       {
        if (TimeDayOfWeek(iTime(Instrument[j],period,bar))==4) CurSwap[j]+=3*DaySwap[j];
        else CurSwap[j]+=DaySwap[j];
       } break;
       case 1:
       {
        if (TimeDayOfWeek(iTime(Instrument[j],period,bar))==1) CurSwap[j]+=3*DaySwap[j];
        else CurSwap[j]+=DaySwap[j];
       }
      }
     }
     if (Type[j]==OP_BUY)
     {
      if (open)
      {
       lotsize=LotSize(Instrument[j],iTime(NULL,period,i),false);
       equityopen+=Commission[j]+CurSwap[j]+(iOpen(Instrument[j],period,bar)-OpenPrice[j])*Lots[j]*lotsize;
      }
      lotsize=LotSize(Instrument[j],iTime(NULL,period,i),true);
      equityclose+=Commission[j]+CurSwap[j]+(iClose(Instrument[j],period,bar)-OpenPrice[j])*Lots[j]*lotsize;
     }
     else
     {
      spread=MarketInfo(Instrument[j],MODE_POINT)*MarketInfo(Instrument[j],MODE_SPREAD);
      if (open)
      {
       lotsize=LotSize(Instrument[j],iTime(NULL,period,i),false);
       equityopen+=Commission[j]+CurSwap[j]+(OpenPrice[j]-iOpen(Instrument[j],period,bar)-spread)*Lots[j]*lotsize;
      }
      lotsize=LotSize(Instrument[j],iTime(NULL,period,i),true);
      equityclose+=Commission[j]+CurSwap[j]+(OpenPrice[j]-iClose(Instrument[j],period,bar)-spread)*Lots[j]*lotsize;
     }
    }
   }
   if (open)
   {
    equityopen+=CurrentBalance;
    equityhigh=equityopen;
    equitylow=equityopen;
    open=false;
   }
   equityclose+=CurrentBalance;
   if (equityclose<equitylow)  equitylow=equityclose;
   if (equityclose>equityhigh) equityhigh=equityclose;
   if (Show_Info) Information(equityclose);
  }
  ArrayResize(OpenTime_Ticket,opentotal);
  if (opentotal>0)
  {
   for (i=0;i<opentotal;i++) if (OrderSelect(i,SELECT_BY_POS,MODE_TRADES)) OpenTime_Ticket[i][1]=OrderTicket();
  }
 }
 else
 {
  if (TimeBar!=Time[0])
  {
   TimeBar=Time[0];
   equityopen=0.0;
   equityclose=0.0;
   open=true;
  }
  if (Only_Magics=="" && Only_Symbols=="" && !Only_Current)
  {
   if (Show_Balance) Balance[0]=NormalizeDouble(AccountBalance(),2);
   if (Show_Equity)
   {
    if (open)
    {
     equityopen=AccountEquity();
     equityhigh=equityopen;
     equitylow=equityopen;
     open=false;
    }
    equityclose=AccountEquity();
    if (equityclose<equitylow)  equitylow=equityclose;
    if (equityclose>equityhigh) equityhigh=equityclose;
   }
   if (Show_Info) Information(AccountEquity());
  }
  else
  {
   opentotal=ArraySize(OpenTime_Ticket);
   if (opentotal>0)
   {
    for (i=0;i<opentotal;i++)
    {
     if (!OrderSelect(OpenTime_Ticket[i][1],SELECT_BY_TICKET)) continue;
     if (OrderCloseTime()==0) continue;
     else if (Select()) CurrentBalance+=OrderCommission()+OrderSwap()+OrderProfit();
    }
   }
   equityclose=0.0;
   opentotal=OrdersTotal();
   if (opentotal>0)
   {
    for (i=0;i<opentotal;i++)
    {
     if (!OrderSelect(i,SELECT_BY_POS,MODE_TRADES)) continue;
     if (Select()) equityclose+=OrderCommission()+OrderSwap()+OrderProfit();
    }
   }
   equityclose+=CurrentBalance;
   if (Show_Balance) Balance[0]=NormalizeDouble(CurrentBalance,2);
   if (Show_Equity)
   {
    if (open)
    {
     equityopen=equityclose;
     equitylow=equityopen;
     equityhigh=equityopen;
     open=false;
    }
    if (equityclose<equitylow)  equitylow=equityclose;
    if (equityclose>equityhigh) equityhigh=equityclose;
   }
   if (Show_Info) Information(equityclose);
   ArrayResize(OpenTime_Ticket,opentotal);
   if (opentotal>0)
   {
    for (i=0;i<opentotal;i++) if (OrderSelect(i,SELECT_BY_POS,MODE_TRADES)) OpenTime_Ticket[i][1]=OrderTicket();
   }
  }
  if (Show_Equity)
  {
   if (equityopen<=equityclose)
   {
    EquityBodyDown[0]=EMPTY_VALUE;
    EquityBodyUp[0]=NormalizeDouble(equityclose,2);
    MaskBody[0]=NormalizeDouble(equityopen,2);
    EquityShadeDown[0]=EMPTY_VALUE;
    EquityShadeUp[0]=NormalizeDouble(equityhigh,2);
   }
   else
   {
    EquityBodyUp[0]=EMPTY_VALUE;
    EquityBodyDown[0]=NormalizeDouble(equityopen,2);
    MaskBody[0]=NormalizeDouble(equityclose,2);
    EquityShadeUp[0]=EMPTY_VALUE;
    EquityShadeDown[0]=NormalizeDouble(equityhigh,2);
   }
   MaskShade[0]=NormalizeDouble(equitylow,2);
   if (equityhigh==equitylow) EquityLine[0]=equityhigh; else EquityLine[0]=EMPTY_VALUE;
  }
 }
 name="Equity Level";
 if (ObjectFind(name)==-1) ObjectCreate(name,OBJ_HLINE,Window,0,equityclose);
 ObjectSet(name,OBJPROP_PRICE1,equityclose);
 ObjectSet(name,OBJPROP_COLOR,LightSlateGray);
 if (Show_Info)
 {
  name="Maximal Drawdown";
  if (ObjectFind(name)==-1) ObjectCreate(name,OBJ_LABEL,Window,0,0);
  text=StringConcatenate(name,": ",DoubleToStr(Drawdown,2)," (",DoubleToStr(100*Drawdown/MaxPeak,2),"%)");
  ObjectSetText(name,text);
  ObjectSet(name,OBJPROP_XDISTANCE,10);
  ObjectSet(name,OBJPROP_YDISTANCE,10);
  ObjectSet(name,OBJPROP_CORNER,1);
  ObjectSet(name,OBJPROP_COLOR,Silver);
  name="Recovery Factor";
  if (ObjectFind(name)==-1) ObjectCreate(name,OBJ_LABEL,Window,0,0);
  if (Drawdown>0) RecoveryFactor=equityclose/Drawdown;
  text=StringConcatenate(name,": ",DoubleToStr(RecoveryFactor,2));
  ObjectSetText(name,text);
  ObjectSet(name,OBJPROP_XDISTANCE,10);
  ObjectSet(name,OBJPROP_YDISTANCE,30);
  ObjectSet(name,OBJPROP_CORNER,1);
  ObjectSet(name,OBJPROP_COLOR,Silver);
 }
 //Print("Calculating - ",GetTickCount()-tick," ms");
 return(0);
}
//+----------------------------------------------------------------------------+
//|                                                                |
//+----------------------------------------------------------------------------+
void ReadDeals(int n)
{
 OpenBar[n]=iBarShift(NULL,period,OrderOpenTime());
 Type[n]=OrderType();
 if (OrderType()>5) Instrument[n]=OrderComment();
 else Instrument[n]=OrderSymbol();
 Lots[n]=OrderLots();
 OpenPrice[n]=OrderOpenPrice();
 if (OrderCloseTime()!=0)
 {
  CloseBar[n]=iBarShift(NULL,period,OrderCloseTime());
  ClosePrice[n]=OrderClosePrice();
 }
 else
 {
  CloseBar[n]=0;
  ClosePrice[n]=0.0;
 }
 Commission[n]=OrderCommission();
 Swap[n]=OrderSwap();
 Profit[n]=OrderProfit();
 CurSwap[n]=0.0;
 int swapdays=0;
 for (int b=OpenBar[n]-1;b>=CloseBar[n];b--)
 {
  if (TimeDayOfWeek(iTime(NULL,period,b))!=TimeDayOfWeek(iTime(NULL,period,b+1)))
  {
   switch (MarketInfo(Instrument[n],MODE_PROFITCALCMODE))
   {
    case 0:
    {
     if (TimeDayOfWeek(iTime(NULL,period,b))==4) swapdays+=3;
     else swapdays++;
    } break;
    case 1:
    {
     if (TimeDayOfWeek(iTime(NULL,period,b))==1) swapdays+=3;
     else swapdays++;
    }
   }
  }
 }
 if (swapdays>0) DaySwap[n]=Swap[n]/swapdays; else DaySwap[n]=0.0;
 Magic[n]=OrderMagicNumber();
 if (Lots[n]==0)
 {
  string ticket=StringSubstr(OrderComment(),StringFind(OrderComment(),"#")+1);
  if (OrderSelect(StrToInteger(ticket),SELECT_BY_TICKET,MODE_HISTORY)) Lots[n]=OrderLots();
 }
}
//+----------------------------------------------------------------------------+
//|                                                 |
//+----------------------------------------------------------------------------+
void Information(double equity)
{
 if (MaxProfit<equity) MaxProfit=equity;
 if (Drawdown<(MaxProfit-equity))
 {
  Drawdown=MaxProfit-equity;
  MaxPeak=MaxProfit;
 }
}
//+----------------------------------------------------------------------------+
//|                                                 |
//+----------------------------------------------------------------------------+
double LotSize(string symbol, datetime tbar, bool close)
{
 double size;
 string BQ,currency=AccountCurrency();
 switch (MarketInfo(symbol,MODE_PROFITCALCMODE))
 {
  case 0:
  {
   int sbar=iBarShift(symbol,period,tbar);
   size=MarketInfo(symbol,MODE_LOTSIZE);
   if (StringSubstr(symbol,3,3)=="USD") break;
   if (StringSubstr(symbol,0,3)=="USD")
   {
    if (close) size=size/iClose(symbol,period,sbar);
    else size=size/iOpen(symbol,period,sbar);
   }
   else
   {
    BQ=StringSubstr(symbol,0,3)+"USD";
    if (iClose(BQ,period,0)==0) BQ="USD"+StringSubstr(symbol,0,3);
    if (iClose(BQ,period,0)==0) break;
    int BQbar=iBarShift(BQ,period,tbar);
    if (StringSubstr(BQ,0,3)=="USD")
    {
     if (close) size=size/iClose(BQ,period,BQbar)/iClose(symbol,period,sbar);
     else size=size/iOpen(BQ,period,BQbar)/iOpen(symbol,period,sbar);
    }
    else
    {
     if (close) size=size*iClose(BQ,period,BQbar)/iClose(symbol,period,sbar);
     else size=size*iOpen(BQ,period,BQbar)/iOpen(symbol,period,sbar);
    }
   }
  } break;
  case 1: size=MarketInfo(symbol,MODE_LOTSIZE); break;
  case 2: size=MarketInfo(symbol,MODE_TICKVALUE)/MarketInfo(symbol,MODE_TICKSIZE);
 }
 if (currency!="USD")
 {
  BQ=currency+"USD";
  if (iClose(BQ,period,0)==0)
  {
   BQ="USD"+currency;
   if (close) size*=iClose(BQ,period,iBarShift(BQ,period,tbar));
   else size*=iOpen(BQ,period,iBarShift(BQ,period,tbar));
  }
  else
  {
   if (close) size/=iClose(BQ,period,iBarShift(BQ,period,tbar));
   else size/=iOpen(BQ,period,iBarShift(BQ,period,tbar));
  }
 }
 return(size);
}
//+----------------------------------------------------------------------------+
//|                                                      |
//+----------------------------------------------------------------------------+
bool Select()
{
 if (OrderType()>5) return(true);
 if (OrderType()>1) return(false);
 if (Only_Magics!="")
 {
  if (StringFind(Only_Magics,DoubleToStr(OrderMagicNumber(),0))==-1) return(false);
 }
 if (Only_Symbols!="")
 {
  if (StringFind(Only_Symbols,OrderSymbol())==-1) return(false);
 }
 else if (Only_Current && OrderSymbol()!=Symbol()) return(false);
 return(true);
}
//+----------------------------------------------------------------------------+